(*********************************************************************)
(* the signature of a moduke to pass common global values *)
(*********************************************************************)

open Cil

(** Type to pass common global values *)
module type ARGS = sig
  (* current file *)
  val file : file

  (* number of rounds to sequentialize *)
  val rounds : int

  (* current job *)
  val jobVar : varinfo

  (* round in which current job ends *)
  val jobEndVar : varinfo

  (* current task *)
  val taskVar : varinfo

  (* current round *)
  val roundVar : varinfo

  (* lock variable *)
  val lockVar : varinfo

  (* The current hyper period *)
  val hyperPeriodVar : varinfo
end


(*********************************************************************)
(** Dummy Feature description for CIL compilation *)
(*********************************************************************)
let feature : featureDescr = 
{
  fd_name = "rekargs";
  fd_enabled = ref false;
  fd_description = "rekargs";
  fd_extraopt = [ ];
  fd_doit = (fun f -> ());
  fd_post_check = false;
}
