(**** This module supplies Command Line Options for REK ****)
open Cil

let nopbounds = ref false
let dopo = ref false
let inlineAll = ref false  
let noarray = ref false
let nopriorcs = ref false
let nesting = ref true
let nohyperunroll = ref false

let feature : featureDescr = 
{
  fd_name = "rekoptions";
  fd_enabled = ref true;
  fd_description = "Common command line options for REK";
  fd_extraopt = 
    [
      ("--inline-all", Arg.Set inlineAll, 
       " Inline all functions after instrumentation");
      ("--nopbounds", Arg.Set nopbounds, 
       " Disable preemption bounds constraints");
      ("--po", Arg.Set dopo, 
       " Enable partial order reduction");
      ("--noarray", Arg.Set noarray,
       " Do not use arrays in the encoding");
      ("--nopriorcs", Arg.Set nopriorcs,
       " No priority checks inside the context switch");
      ("--nonesting", Arg.Clear nesting,
       " Do not include nesting-constraints in job scheduler");
      ("--nohyperunroll", Arg.Set nohyperunroll, 
       "Do not use hyper-period unrolling")
    ];
  fd_doit = (fun f -> ());
  fd_post_check = false;
}
