#!/bin/bash
# /* ================================== */
# /* LLREK LICENSE */
# /* ================================== */
# /* Copyright (c) 2013 Carnegie Mellon University. */
# /* All Rights Reserved. */
# 
# /* Redistribution and use in source and binary forms, with or without */
# /* modification, are permitted provided that the following conditions are */
# /* met: */
# 
# /* 1. LLREK includes and/or makes use of certain third party software */
# /* ("Third Party Software"). You agree to comply with any and all the */
# /* Third Party Software terms and conditions listed below and/or */
# /* contained in any separate license file distributed with LLREK. The */
# /* parties who own the Third Party Software ("Third Party Licensors") are */
# /* intended third party beneficiaries to this License with respect to the */
# /* terms applicable to their Third Party Software. */
# 
# /* 2. Redistributions of source code must retain the above copyright */
# /* notice, this list of conditions and the following acknowledgments and */
# /* disclaimers. */
# 
# /* 3. Redistributions in binary form must reproduce the above copyright */
# /* notice, this list of conditions and the following acknowledgments and */
# /* disclaimers in the documentation and/or other materials provided with */
# /* the distribution. */
# 
# /* 4. Products derived from this software may not include Carnegie */
# /* Mellon University, "SEI and/or Software Engineering */
# /* Institute" in the name of such derived product, nor shall Carnegie */
# /* Mellon University, "SEI and/or Software Engineering */
# /* Institute" be used to endorse or promote products derived from this */
# /* software without prior written permission. For written permission, */
# /* please contact permission@sei.cmu.edu. */
# 
# /* This material is based upon work funded and supported by the */
# /* Department of Defense under Contract No. FA8721-05-C-0003 with */
# /* Carnegie Mellon University for the operation of the Software */
# /* Engineering Institute, a federally funded research and development */
# /* center. */
# 
# /* Any opinions, findings and conclusions or recommendations expressed in */
# /* this material are those of the author(s) and do not necessarily */
# /* reflect the views of the United States Department of Defense. */
# 
# /* NO WARRANTY. THIS CARNEGIE MELLON UNIVERSITY AND SOFTWARE ENGINEERING */
# /* INSTITUTE MATERIAL IS FURNISHEDON AN AS-IS BASIS. CARNEGIE */
# /* MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER EXPRESSED OR */
# /* IMPLIED, AS TO ANY MATTER INCLUDING, BUT NOT LIMITED TO, WARRANTY OF */
# /* FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY, OR RESULTS */
# /* OBTAINED FROM USE OF THE MATERIAL. CARNEGIE MELLON UNIVERSITY DOES NOT */
# /* MAKE ANY WARRANTY OF ANY KIND WITH RESPECT TO FREEDOM FROM PATENT, */
# /* TRADEMARK, OR COPYRIGHT INFRINGEMENT. */
# 
# /* This material has been approved for public release and unlimited */
# /* distribution. */
# 
# /* DM-0000665 */
# 
# /* Third Party Software licenses: */
# /* ================================== */
# /* CBMC LICENSE */
# /* ================================== */
# 
# /* (C) 2001-2011, Daniel Kroening, Edmund Clarke, */
# /* Computer Science Department, Oxford University */
# /* Computer Systems Institute, ETH Zurich */
# /* Computer Science Department, Carnegie Mellon University */
# 
# /* All rights reserved. Redistribution and use in source and binary forms, with */
# /* or without modification, are permitted provided that the following */
# /* conditions are met: */
# 
# /*   1. Redistributions of source code must retain the above copyright */
# /*      notice, this list of conditions and the following disclaimer. */
# 
# /*   2. Redistributions in binary form must reproduce the above copyright */
# /*      notice, this list of conditions and the following disclaimer in the */
# /*      documentation and/or other materials provided with the distribution. */
# 
# /*   3. All advertising materials mentioning features or use of this software */
# /*      must display the following acknowledgement: */
# 
# /*      This product includes software developed by Daniel Kroening, */
# /*      Edmund Clarke, */
# /*      Computer Science Department, Oxford University */
# /*      Computer Systems Institute, ETH Zurich */
# /*      Computer Science Department, Carnegie Mellon University */
# 
# /*   4. Neither the name of the University nor the names of its contributors */
# /*      may be used to endorse or promote products derived from this software */
# /*      without specific prior written permission. */
# 
#    
# /* THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS `AS IS'' AND ANY */
# /* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED */
# /* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE */
# /* DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY */
# /* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES */
# /* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; */
# /* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND */
# /* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT */
# /* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF */
# /* THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
# 
# /* ================================== */
# /* CIL LICENSE */
# /* ================================== */
# 
# /* Copyright (c) 2001-2011, */
# /*  George C. Necula    <necula@cs.berkeley.edu> */
# /*  Scott McPeak        <smcpeak@cs.berkeley.edu> */
# /*  Wes Weimer          <weimer@cs.berkeley.edu> */
# /*  Ben Liblit          <liblit@cs.wisc.edu> */
# /*  Matt Harren         <matth@cs.berkeley.edu> */
# /*  Gabriel Kerneis     <kerneis@pps.jussieu.fr> */
# /* All rights reserved. */
# 
# /* Redistribution and use in source and binary forms, with or without */
# /* modification, are permitted provided that the following conditions are met: */
# 
# /* 1. Redistributions of source code must retain the above copyright notice, */
# /* this list of conditions and the following disclaimer. */
# 
# /* 2. Redistributions in binary form must reproduce the above copyright notice, */
# /* this list of conditions and the following disclaimer in the documentation */
# /* and/or other materials provided with the distribution. */
# 
# /* 3. The names of the contributors may not be used to endorse or promote */
# /* products derived from this software without specific prior written */
# /* permission. */
# 
# /* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" */
# /* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE */
# /* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE */
# /* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE */
# /* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR */
# /* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF */
# /* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS */
# /* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN */
# /* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) */
# /* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE */
# /* POSSIBILITY OF SUCH DAMAGE. */
# 
# 
# /* (See http://www.opensource.org/licenses/bsd-license.php) */
# 
# /* ================================== */
# /* STP LICENSE */
# /* ================================== */
# 
# /* /\******************************************************************** */
# /*  * PROGRAM NAME: STP (Simple Theorem Prover)	 */
# /*  *		 */
# /*  * AUTHORS: Vijay Ganesh */
# /*  *	 */
# /*  * BEGIN DATE: November, 2005 */
# /*  ********************************************************************\/ */
# 
# /* The MIT License */
# 
# /* Copyright (c) 2008 Vijay Ganesh */
# 
# /* Permission is hereby granted, free of charge, to any person obtaining */
# /* a copy of this software and associated documentation files (the */
# /* "Software"), to deal in the Software without restriction, including */
# /* without limitation the rights to use, copy, modify, merge, publish, */
# /* distribute, sublicense, and/or sell copies of the Software, and to */
# /* permit persons to whom the Software is furnished to do so, subject to */
# /* the following conditions: */
# 
# /* The above copyright notice and this permission notice shall be */
# /* included in all copies or substantial portions of the Software. */
# 
# /* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, */
# /* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF */
# /* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND */
# /* NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE */
# /* LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION */
# /* OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION */
# /* WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */
# 
# /* ================================== */
# /* UFO LICENSE */
# /* ================================== */
# 
# /* Copyright (c) 2012 Carnegie Mellon University. */
# /* All rights reserved. */
# 
# /* Redistribution and use in source and binary forms, with or without */
# /* modification, are permitted provided that the following conditions are */
# /* met: */
# 
# /*    * Redistributions of source code must retain the above copyright */
# /*      notice, this list of conditions and the following disclaimer. */
# 
# /*    * Redistributions in binary form must reproduce the above copyright */
# /*      notice, this list of conditions and the following disclaimer in */
# /*      the documentation and/or other materials provided with the */
# /*      distribution. */
# 
# /*    * Neither the name of Carnegie Mellon University nor the Software */
# /*      Engineering Institute and its employees may be used to endorse or */
# /*      promote products derived from this software without specific */
# /*      prior written permission from permission@sei.cmu.edu. */
# 
# /* NO WARRANTY */
# /* ANY SOFTWARE, INFORMATION, MATERIALS, SERVICES, INTELLECTUAL PROPERTY */
# /* OR OTHER PROPERTY OR RIGHTS GRANTED OR PROVIDED BY CARNEGIE MELLON */
# /* PURSUANT TO THIS AGREEMENT (HEREINAFTER THE "DELIVERABLES") ARE ON AN */
# /* "AS-IS" BASIS. CARNEGIE MELLON MAKES NO WARRANTIES OF ANY KIND, EITHER */
# /* EXPRESS OR IMPLIED AS TO ANY MATTER INCLUDING, BUT NOT LIMITED TO, */
# /* WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY, */
# /* INFORMATIONAL CONTENT, NONINFRINGEMENT, OR ERROR-FREE */
# /* OPERATION. CARNEGIE MELLON SHALL NOT BE LIABLE FOR ANY DAMAGES */
# /* WHATSOEVER, REGARDLESS OF WHETHER CARNEGIE MELLON WAS AWARE OF THE */
# /* POSSIBILITY OF SUCH DAMAGES.  YOU AGREE THAT YOU WILL NOT MAKE ANY */
# /* WARRANTY ON BEHALF OF CARNEGIE MELLON, EXPRESS OR IMPLIED, TO ANY */
# /* PERSON CONCERNING THE APPLICATION OF OR THE RESULTS TO BE OBTAINED */
# /* WITH THE DELIVERABLES UNDER THIS AGREEMENT. */
# 
# /* By using this software, you hereby agree to defend, indemnify, and */
# /* hold harmless Carnegie Mellon, its trustees, officers, employees, and */
# /* agents from all claims or demands made against them (and any related */
# /* losses, expenses, or attorney's fees) arising out of, or relating to */
# /* Licensee's and/or its sub licensees' negligent use or willful misuse */
# /* of or negligent conduct or willful misconduct regarding the Software, */
# /* facilities, or other rights or assistance granted by Carnegie Mellon */
# /* under this Agreement, including, but not limited to, any claims of */
# /* product liability, personal injury, death, damage to property, or */
# /* violation of any laws or regulations. */
# 
# /* Carnegie Mellon University Software Engineering Institute authored */
# /* materials are sponsored by the U.S. Department of Defense under */
# /* Contract F19628-00-C-0003. Carnegie Mellon University retains */
# /* copyrights in all material produced under this contract. The */
# /* U.S. Government retains a non-exclusive, royalty-free license to */
# /* publish or reproduce these materials, or allow others to do so, for */
# /* U.S. Government purposes only pursuant to the copyright license under */
# /* the contract clause at 252.227.7013. */
# 
# 
# 
# /* ================================== */
# /* Z3 LICENSE */
# /* ================================== */
# 
# /* Microsoft Research License Agreement */
# /* Non-Commercial Use Only  */
# /* Z3 */
# /* _____________________________________________________________________ */
# 
# /* This Microsoft Research License Agreement, including all exhibits */
# /* ("MSR-LA") is a legal agreement between you and Microsoft Corporation */
# /* ("Microsoft" or "we") for the data identified above, which may include */
# /* associated materials, text or speech files, associated media and */
# /* "online" or electronic documentation and any updates we provide in our */
# /* discretion (together, the "Software"). */
# 
# /* By installing, copying, or otherwise using this Software, you agree to */
# /* be bound by the terms of this MSR-LA. If you do not agree, do not */
# /* install copy or use the Software. The Software is protected by */
# /* copyright and other intellectual property laws and is licensed, not */
# /* sold. */
# 
# /* SCOPE OF RIGHTS: */
# 
# /* You may use, copy, reproduce, and distribute this Software for any */
# /* non-commercial purpose, subject to the restrictions in this */
# /* MSR-LA. Some purposes which can be non-commercial are teaching, */
# /* academic research, public demonstrations and personal */
# /* experimentation. You may also distribute this Software with books or */
# /* other teaching materials, or publish the Software on websites, that */
# /* are intended to teach the use of the Software for academic or other */
# /* non-commercial purposes. */
# 
# /* You may not use or distribute this Software or any derivative works in */
# /* any form for commercial purposes. Examples of commercial purposes */
# /* would be running business operations, licensing, leasing, or selling */
# /* the Software, distributing the Software for use with commercial */
# /* products, using the Software in the creation or use of commercial */
# /* products or any other activity which purpose is to procure a */
# /* commercial gain to you or others. */
# 
# /* You may create derivative works of the Software source code and */
# /* distribute the modified Software solely for non-commercial academic */
# /* purposes, as provided herein. If you distribute the Software or any */
# /* derivative works of the Software, you will distribute them under the */
# /* same terms and conditions as in this license, and you will not grant */
# /* other rights to the Software or derivative works that are different */
# /* from those provided by this MSR-LA. */
# 
# /* If you have created derivative works of the Software, and distribute */
# /* such derivative works, you will cause the modified files to carry */
# /* prominent notices so that recipients know that they are not receiving */
# /* the original Software. Such notices must state: (i) that you have */
# /* changed the Software; and (ii) the date of any changes.  In return, we */
# /* simply require that you agree: */
# 
# /* 1. That you will not remove any copyright or other notices from the */
# /* Software. */
# 
# /* 2. That if any of the Software is in binary format, you will not */
# /* attempt to modify such portions of the Software, or to reverse */
# /* engineer or decompile them, except and only to the extent authorized */
# /* by applicable law. */
# 
# /* 3. That Microsoft is granted back, without any restrictions or */
# /* limitations, a non-exclusive, perpetual, irrevocable, royalty-free, */
# /* assignable and sub-licensable license, to reproduce, publicly perform */
# /* or display, install, use, modify, post, distribute, make and have */
# /* made, sell and transfer your modifications to and/or derivative works */
# /* of the Software source code or data, for any purpose. */
# 
# /* 4. That any feedback about the Software provided by you to us is */
# /* voluntarily given, and Microsoft shall be free to use the feedback as */
# /* it sees fit without obligation or restriction of any kind, even if the */
# /* feedback is designated by you as confidential. */
# 
# /* 5. THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES. THIS MEANS NO */
# /* EXPRESS, IMPLIED OR STATUTORY WARRANTY, INCLUDING WITHOUT LIMITATION, */
# /* WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, ANY */
# /* WARRANTY AGAINST INTERFERENCE WITH YOUR ENJOYMENT OF THE SOFTWARE OR */
# /* ANY WARRANTY OF TITLE OR NON-INFRINGEMENT. THERE IS NO WARRANTY THAT */
# /* THIS SOFTWARE WILL FULFILL ANY OF YOUR PARTICULAR PURPOSES OR */
# /* NEEDS. ALSO, YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE */
# /* THE SOFTWARE OR DERIVATIVE WORKS. */
# 
# /* 6. THAT NEITHER MICROSOFT NOR ANY CONTRIBUTOR TO THE SOFTWARE WILL BE */
# /* LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS MSR-LA, */
# /* INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL */
# /* DAMAGES, TO THE MAXIMUM EXTENT THE LAW PERMITS, NO MATTER WHAT LEGAL */
# /* THEORY IT IS BASED ON. ALSO, YOU MUST PASS THIS LIMITATION OF */
# /* LIABILITY ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS. */
# 
# /* 7. That we have no duty of reasonable care or lack of negligence, and */
# /* we are not obligated to (and will not) provide technical support for */
# /* the Software. */
# 
# /* 8. That if you breach this MSR-LA or if you sue anyone over patents */
# /* that you think may apply to or read on the Software or anyone's use of */
# /* the Software, this MSR-LA (and your license and rights obtained */
# /* herein) terminate automatically. Upon any such termination, you shall */
# /* destroy all of your copies of the Software immediately. Sections 3, 4, */
# /* 5, 6, 7, 8, 11 and 12 of this MSR-LA shall survive any termination of */
# /* this MSR-LA. */
# 
# /* 9. That the patent rights, if any, granted to you in this MSR-LA only */
# /* apply to the Software, not to any derivative works you make. */
# 
# /* 10. That the Software may be subject to U.S. export jurisdiction at */
# /* the time it is licensed to you, and it may be subject to additional */
# /* export or import laws in other places. You agree to comply with all */
# /* such laws and regulations that may apply to the Software after */
# /* delivery of the Software to you. */
# 
# /* 11. That all rights not expressly granted to you in this MSR-LA are */
# /* reserved. */
# 
# /* 12. That this MSR-LA shall be construed and controlled by the laws of */
# /* the State of Washington, USA, without regard to conflicts of law. If */
# /* any provision of this MSR-LA shall be deemed unenforceable or contrary */
# /* to law, the rest of this MSR-LA shall remain in full effect and */
# /* interpreted in an enforceable manner that most nearly captures the */
# /* intent of the original language. */
# 
# /* ================================== */
# /* LLVM LICENSE */
# /* ================================== */
# 
# /* ============================================================================== */
# /* LLVM Release License */
# /* ============================================================================== */
# /* University of Illinois/NCSA */
# /* Open Source License */
# 
# /* Copyright (c) 2003-2010 University of Illinois at Urbana-Champaign. */
# /* All rights reserved. */
# 
# /* Developed by: */
# 
# /*     LLVM Team */
# 
# /*     University of Illinois at Urbana-Champaign */
# 
# /*     http://llvm.org */
# 
# /* Permission is hereby granted, free of charge, to any person obtaining a copy of */
# /* this software and associated documentation files (the "Software"), to deal with */
# /* the Software without restriction, including without limitation the rights to */
# /* use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies */
# /* of the Software, and to permit persons to whom the Software is furnished to do */
# /* so, subject to the following conditions: */
# 
# /*     * Redistributions of source code must retain the above copyright notice, */
# /*       this list of conditions and the following disclaimers. */
# 
# /*     * Redistributions in binary form must reproduce the above copyright notice, */
# /*       this list of conditions and the following disclaimers in the */
# /*       documentation and/or other materials provided with the distribution. */
# 
# /*     * Neither the names of the LLVM Team, University of Illinois at */
# /*       Urbana-Champaign, nor the names of its contributors may be used to */
# /*       endorse or promote products derived from this Software without specific */
# /*       prior written permission. */
# 
# /* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR */
# /* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS */
# /* FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE */
# /* CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER */
# /* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, */
# /* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE */
# /* SOFTWARE. */
# 
# /* ============================================================================== */
# /* Copyrights and Licenses for Third Party Software Distributed with LLVM: */
# /* ============================================================================== */
# /* The LLVM software contains code written by third parties.  Such software will */
# /* have its own individual LICENSE.TXT file in the directory in which it appears. */
# /* This file will describe the copyrights, license, and restrictions which apply */
# /* to that code. */
# 
# /* The disclaimer of warranty in the University of Illinois Open Source License */
# /* applies to all code in the LLVM Distribution, and nothing in any of the */
# /* other licenses gives permission to use the names of the LLVM Team or the */
# /* University of Illinois to endorse or promote products derived from this */
# /* Software. */
# 
# /* The following pieces of software have additional or alternate copyrights, */
# /* licenses, and/or restrictions: */
# 
# /* Program             Directory */
# /* -------             --------- */
# /* Autoconf            llvm/autoconf */
# /*                     llvm/projects/ModuleMaker/autoconf */
# /*                     llvm/projects/sample/autoconf */
# /* CellSPU backend     llvm/lib/Target/CellSPU/README.txt */
# /* Google Test         llvm/utils/unittest/googletest */
# /* OpenBSD regex       llvm/lib/Support/{reg*, COPYRIGHT.regex} */
# 
# /* ====================================== */
# /* LICENSES OF COMPONENTS LINKED BY STP */
# /* ====================================== */
# 
# /* STP links to copyrighted librarys: */
# /* 	* Minisat Copyright (c) 2003-2006, Niklas Een, Niklas Sorensson. */
# /* 	* Bit::Vector Copyright (c) 1995 - 2004 by Steffen Beyer.  */
# /* 	* CVC's SMT-LIB Parser  Copyright (C) 2004 by the Board of Trustees of Leland Stanford Junior University and by New York University. */
# /* 	* CryptoMinisat Copyright (c) 2009 Mate Soos */
# /* 	* ocaml-wrapper Copyright BitBlaze, 2007. All rights reserved. */
# /* 	* ABC by Alan Mishchenko */
# /* 	* Boost by various: http://www.boost.org/ */
# 
# /* MINISAT */
# /* 	/\**************************************************************************************** */
# /* 	MiniSat -- Copyright (c) 2003-2006, Niklas Een, Niklas Sorensson */
# 
# /* 	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and */
# /* 	associated documentation files (the "Software"), to deal in the Software without restriction, */
# /* 	including without limitation the rights to use, copy, modify, merge, publish, distribute, */
# /* 	sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is */
# /* 	furnished to do so, subject to the following conditions: */
# 
# /* 	The above copyright notice and this permission notice shall be included in all copies or */
# /* 	substantial portions of the Software. */
# 
# /* 	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT */
# /* 	NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND */
# /* 	NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, */
# /* 	DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT */
# /* 	OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */
# /* 	**************************************************************************************************\/ */
# 
# /* Bit::Vector */
# /* 	/\*****************************************************************************\/ */
# /* 	/\*  LICENSE:                                                                 *\/ */
# /* 	/\*****************************************************************************\/ */
# /* 	/\*                                                                           *\/ */
# /* 	/\*    This library is free software; you can redistribute it and/or          *\/ */
# /* 	/\*    modify it under the terms of the GNU Library General Public            *\/ */
# /* 	/\*    License as published by the Free Software Foundation; either           *\/ */
# /* 	/\*    version 2 of the License, || (at your option) any later version.       *\/ */
# /* 	/\*                                                                           *\/ */
# /* 	/\*    This library is distributed in the hope that it will be useful,        *\/ */
# /* 	/\*    but WITHOUT ANY WARRANTY; without even the implied warranty of         *\/ */
# /* 	/\*    MERCHANTABILITY || FITNESS FOR A PARTICULAR PURPOSE. See the GNU       *\/ */
# /* 	/\*    Library General Public License for more details.                       *\/ */
# /* 	/\*                                                                           *\/ */
# /* 	/\*    You should have received a copy of the GNU Library General Public      *\/ */
# /* 	/\*    License along with this library; if not, write to the                  *\/ */
# /* 	/\*    Free Software Foundation, Inc.,                                        *\/ */
# /* 	/\*    59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                  *\/ */
# /* 	/\*                                                                           *\/ */
# /* 	/\*    || download a copy from ftp://ftp.gnu.org/pub/gnu/COPYING.LIB-2.0      *\/ */
# /* 	/\*                                                                           *\/ */
# /* 	/\*****************************************************************************\/ */
# 
# /* CVC's SMT-LIB Parser */
# /* 	 /\******************************************************************** */
# /* 	   * */
# /* 	   * \file smtlib.y */
# /* 	   *  */
# /* 	   * Author: Sergey Berezin, Clark Barrett */
# /* 	   *  */
# /* 	   * Created: Apr 30 2005 */
# /* 	   * */
# /* 	   * <hr> */
# /* 	   * Copyright (C) 2004 by the Board of Trustees of Leland Stanford */
# /* 	   * Junior University and by New York University.  */
# /* 	   * */
# /* 	   * License to use, copy, modify, sell and/or distribute this software */
# /* 	   * and its documentation for any purpose is hereby granted without */
# /* 	   * royalty, subject to the terms and conditions defined in the \ref */
# /* 	   * LICENSE file provided with this distribution.  In particular: */
# /* 	   * */
# /* 	   * - The above copyright notice and this permission notice must appear */
# /* 	   * in all copies of the software and related documentation. */
# /* 	   * */
# /* 	   * - THE SOFTWARE IS PROVIDED "AS-IS", WITHOUT ANY WARRANTIES, */
# /* 	   * EXPRESSED OR IMPLIED.  USE IT AT YOUR OWN RISK. */
# /* 	   *  */
# /* 	   * <hr> */
# /* 	   ********************************************************************\/ */
# 
# /* Cryptominisat */
# /* 	CryptoMiniSat -- Copyright (c) 2009 Mate Soos */
# 
# /* 	Permission is hereby granted, free of charge, to any person obtaining a */
# /* 	copy of this software and associated documentation files (the */
# /* 	"Software"), to deal in the Software without restriction, including */
# /* 	without limitation the rights to use, copy, modify, merge, publish, */
# /* 	distribute, sublicense, and/or sell copies of the Software, and to */
# /* 	permit persons to whom the Software is furnished to do so, subject to */
# /* 	the following conditions: */
# 
# /* 	The above copyright notice and this permission notice shall be included */
# /* 	in all copies or substantial portions of the Software. */
# 
# /* 	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS */
# /* 	OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF */
# /* 	MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND */
# /* 	NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE */
# /* 	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION */
# /* 	OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION */
# /* 	WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */
# 
# 
# /* ocaml-wrapper */
# /* 	////////////////////////////////////////////////////////// */
# /* 	// */
# /* 	// Owned and copyright BitBlaze, 2007. All rights reserved. */
# /* 	//  */
# /* 	////////////////////////////////////////////////////////// */
# 
# /* 	Permission is hereby granted, free of charge, to any person obtaining */
# /* 	a copy of this software and associated documentation files (the */
# /* 	"Software"), to deal in the Software without restriction, including */
# /* 	without limitation the rights to use, copy, modify, merge, publish, */
# /* 	distribute, sublicense, and/or sell copies of the Software, and to */
# /* 	permit persons to whom the Software is furnished to do so, subject to */
# /* 	the following conditions: */
# 
# /* 	The above copyright notice and this permission notice shall be */
# /* 	included in all copies or substantial portions of the Software. */
# 
# /* 	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, */
# /* 	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF */
# /* 	MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND */
# /* 	NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE */
# /* 	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION */
# /* 	OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION */
# /* 	WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */
# 
# /* ABC */
# /* 	Copyright (c) The Regents of the University of California. All rights reserved. */
# 
# /* 	Permission is hereby granted, without written agreement and without license or */
# /* 	royalty fees, to use, copy, modify, and distribute this software and its */
# /* 	documentation for any purpose, provided that the above copyright notice and */
# /* 	the following two paragraphs appear in all copies of this software. */
# 
# /* 	IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR */
# /* 	DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF */
# /* 	THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF */
# /* 	CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
# 
# /* 	THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, */
# /* 	BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR */
# /* 	A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, */
# /* 	AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, */
# /* 	SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS. */
# 
# 
# 
# /* Boost */
# /* 	Boost Software License - Version 1.0 - August 17th, 2003 */
# 
# /* 	Permission is hereby granted, free of charge, to any person or organization */
# /* 	obtaining a copy of the software and accompanying documentation covered by */
# /* 	this license (the "Software") to use, reproduce, display, distribute, */
# /* 	execute, and transmit the Software, and to prepare derivative works of the */
# /* 	Software, and to permit third-parties to whom the Software is furnished to */
# /* 	do so, all subject to the following: */
# 
# /* 	The copyright notices in the Software and this entire statement, including */
# /* 	the above license grant, this restriction and the following disclaimer, */
# /* 	must be included in all copies of the Software, in whole or in part, and */
# /* 	all derivative works of the Software, unless such copies or derivative */
# /* 	works are solely in the form of machine-executable object code generated by */
# /* 	a source language processor. */
# 
# /* 	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR */
# /* 	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, */
# /* 	FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT */
# /* 	SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE */
# /* 	FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE, */
# /* 	ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER */
# /* 	DEALINGS IN THE SOFTWARE. */


: ${TLIMIT:="3600"}
ulimit -t $TLIMIT
ulimit -m 2097152
ulimit -v 2097152

CLANG=./bin/clang
OPT=./bin/opt
UFO=./bin/ufo
OUT=$(mktemp -d /tmp/mmc.XXXXXXXX)

SRC=$(echo $1 | awk -F':' '{print $1}')
OPTS=$(echo $1 | awk -F':' '{print $2}')
EFILE="src/$SRC.c -DLLREK $OPTS"

#create bitcode file
gcc -m32 -E -o $OUT/mmc.pp.c $EFILE
$CLANG -m32 -Wno-implicit-int -Wno-implicit-function-declaration -O3 -emit-llvm -c -o $OUT/mmc.1.bc $OUT/mmc.pp.c
$OPT -lowerswitch -indvars -loop-unroll -unroll-threshold=4294967295 -mem2reg < $OUT/mmc.1.bc > $OUT/mmc.2.bc

#run no snapshot
/usr/bin/time -f "BRUNCH_STAT None-Time %E" -o $OUT/time.none $UFO -reksc -reksc-snap=NONE < $OUT/mmc.2.bc &> $OUT/mmc.none.out
grep "^<<OBS>>" $OUT/mmc.none.out
cat $OUT/time.none
RES=$(grep "^VERIFICATION" $OUT/mmc.none.out | awk '{print $2}')
echo "BRUNCH_STAT None-Result $RES"

#run all snapshot
/usr/bin/time -f "BRUNCH_STAT All-Time %E" -o $OUT/time.all $UFO -reksc -reksc-snap=ALL < $OUT/mmc.2.bc &> $OUT/mmc.all.out
grep "^<<OBS>>" $OUT/mmc.all.out
cat $OUT/time.all
RES=$(grep "^VERIFICATION" $OUT/mmc.all.out | awk '{print $2}')
echo "BRUNCH_STAT All-Result $RES"

#run write snapshot
/usr/bin/time -f "BRUNCH_STAT Write-Time %E" -o $OUT/time.write $UFO -reksc -reksc-snap=WRITE < $OUT/mmc.2.bc &> $OUT/mmc.write.out
grep "^<<OBS>>" $OUT/mmc.write.out
cat $OUT/time.write
RES=$(grep "^VERIFICATION" $OUT/mmc.write.out | awk '{print $2}')
echo "BRUNCH_STAT Write-Result $RES"
